const app = getApp()
Page({

    /**
     * 页面的初始数据
     */
    data: {
        logo: ''
    },

    /**
     * 生命周期函数--监听页面加载
     */
    async onLoad(options) { },

    /**
     * 生命周期函数--监听页面初次渲染完成
     */
    onReady() {

    },
    /**
     * 生命周期函数--监听页面显示
     */
    async onShow() {
        const that = this;
        wx.showLoading({ title: '加载中', mask: true })
        await that.searchConfig()
        // 获取Openid
        await that.searchOpenid();
        wx.hideLoading()
    },
    async searchConfig() {
        const that = this;
        const res = await app.$api('config', 'GET', {});
        if (res.errcode == '0') {
            // logo
            if (res.data && res.data.logo_url && res.data.logo_url.length > 0) {
                let logo = res.data.logo_url[0].url
                that.setData({ logo })
            }
            wx.setStorage({ key: "config", data: res.data })
        }
    },
    // 监听用户是否登录
    searchOpenid: async function () {
        wx.login({
            success: async (arr) => {
                const { code: js_code } = arr;
                const { wx_config } = app.globalData;
                const aee = await app.$api('token/app', 'GET', { js_code: js_code, config: wx_config.config });
                if (aee.errcode == '0') {
                    wx.setStorage({ key: "openid", data: aee.data.openid })
                    wx.redirectTo({ url: '/pagesHome/home/index' })
                } else {
                    wx.showToast({ title: `${aee.errmsg}`, icon: 'none' });
                }
            },
        });
    },
    /**
     * 生命周期函数--监听页面隐藏
     */
    onHide() {

    },

    /**
     * 生命周期函数--监听页面卸载
     */
    onUnload() {

    },

    /**
     * 页面相关事件处理函数--监听用户下拉动作
     */
    onPullDownRefresh() {

    },

    /**
     * 页面上拉触底事件的处理函数
     */
    onReachBottom() {

    },

    /**
     * 用户点击右上角分享
     */
    onShareAppMessage() {

    }
})