const app = getApp()
Page({
    data: {
        user: {},
        searchInfo: {},
        list: [],
        total: 0,
        page: 0,
        skip: 0,
        limit: 5,
        statusList: []
    },
    toPath(e) {
        let data = e.detail;
        let url = `/${data.route}`;
        if (data.type == '0') wx.navigateTo({ url })
        else if (data.type == '1') wx.redirectTo({ url })
        else if (data.type == '2') wx.relaunch({ url })
        else if (data.type == '3') wx.switchTab({ url })
    },
    // 查看
    async toView(e) {
        const that = this;
        if (that.data.user._id) {
            const item = e.currentTarget.dataset.item
            wx.navigateTo({ url: '/pagesMatch/apply/index?id=' + item._id })
        } else wx.navigateTo({ url: '/pagesCommon/login/index' })
    },
    // 查询
    async toSearch(e) {
        const that = this;
        if (e.detail.value) that.setData({ 'searchInfo.name': e.detail.value })
        else that.setData({ searchInfo: {} })
        that.clearPage();
        that.search()
    },
    // 分页-触底
    toLower() {
        const that = this;
        let list = that.data.list;
        let limit = that.data.limit;
        if (that.data.total > list.length) {
            wx.showLoading({ title: '加载中', mask: true })
            let page = that.data.page + 1;
            that.setData({ page })
            let skip = page * limit
            that.setData({ skip })
            that.search()
            wx.hideLoading()
        } else {
            wx.showToast({ title: `到底了没数据了`, icon: 'none' });
        }
    },
    // 分页-滚动
    toScroll() {
        // console.log('滚动');
    },
    // 字典
    getDict(value, model) {
        const that = this;
        if (model == 'status') {
            if (value) {
                let data = that.data.statusList.find(i => i.value == value)
                if (data) return data.label
                else return '暂无'
            }
        }
    },
    // 清空列表
    clearPage() {
        const that = this;
        that.setData({ list: [] })
        that.setData({ skip: 0 })
        that.setData({ limit: 5 })
        that.setData({ total: 0 })
    },
    /**
     * 生命周期函数--监听页面加载
     */
    async onLoad(options) {

    },
    /**
     * 生命周期函数--监听页面显示
     */
    async onShow() {
        const that = this;
        wx.showLoading({ title: '加载中', mask: true })
        await that.searchUser()
        await that.searchOther()
        await that.clearPage()
        await that.search()
        wx.hideLoading()
    },
    async searchUser() {
        const that = this;
        wx.getStorage({
            key: 'user',
            async success(res) {
                that.setData({ user: res.data })
            },
            fail(err) {
                // // console.log(err);
            }
        })
    },
    // 查询其他信息
    async searchOther() {
        const that = this;
        let res;
        res = await app.$api('dictData', 'GET', { type: 'match_status', is_use: '0' })
        if (res.errcode == '0') that.setData({ statusList: res.data })
    },
    // 查询通知
    async search() {
        const that = this;
        let info = { skip: that.data.skip, limit: that.data.limit, status: '2' };
        let res = await app.$api('match', 'GET', { ...info, ...that.data.searchInfo })
        if (res.errcode == '0') {
            let list = [...that.data.list, ...res.data]
            for (const val of list) {
                val.status_name = that.getDict(val.status, 'status')
            }
            that.setData({ list })
            that.setData({ total: res.total })
        }
    },
    /**
     * 生命周期函数--监听页面初次渲染完成
     */
    onReady() {

    },

    /**
     * 生命周期函数--监听页面隐藏
     */
    onHide() {

    },

    /**
     * 生命周期函数--监听页面卸载
     */
    onUnload() {

    },

    /**
     * 页面相关事件处理函数--监听用户下拉动作
     */
    onPullDownRefresh() {

    },

    /**
     * 页面上拉触底事件的处理函数
     */
    onReachBottom() {

    },

    /**
     * 用户点击右上角分享
     */
    onShareAppMessage() {

    }
})